Unit DE94R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE96RS_p, UTDE20_p;

procedure DE94R(F :Proc_F_DE; FJ :Proc_F_DE; FX :Proc_F_DE; M :Integer;
                var JSTART :Integer; HMIN :Real; EPS :Real; P :Real;
                var YX :Array of Real; var X :Real; var H :Real;
                var BUL :Boolean; var XP :Real; var YP :Array of Real;
                var A :Array of Real; var A1 :Array of Real;
                var A2 :Array of Real; var RAB :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var R3 :Array of Real; var R4 :Array of Real;
                var YD :Array of Real; var IERR :Integer);

implementation

procedure DE94R(F :Proc_F_DE; FJ :Proc_F_DE; FX :Proc_F_DE; M :Integer;
                var JSTART :Integer; HMIN :Real; EPS :Real; P :Real;
                var YX :Array of Real; var X :Real; var H :Real;
                var BUL :Boolean; var XP :Real; var YP :Array of Real;
                var A :Array of Real; var A1 :Array of Real;
                var A2 :Array of Real; var RAB :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var R3 :Array of Real; var R4 :Array of Real;
                var YD :Array of Real; var IERR :Integer);
var
I,I1,I2,I3,I4 :Integer;
EPS1,HS,XT :Real;
BULD,BULHM :Boolean;
label
_2,_3,_8,_18,_19,_80,_85,_100,_105,_106,_110,_130;
begin
{   BOHEHE OHOO AA  HEABTOHOMHO CCTEM C KOHTPOEM }
{   TOHOCT O PABY PYHE C OOBATECKM OPOPAMMAM }
{   BCEH MATP KO  ACTHO POBOHO O X. }
IERR := 0;
BULD := True;
BULHM := False;
if ( JSTART ) < 0
 then goto _2
 else if ( JSTART ) > 0
       then goto _8
       else goto _8;
_2:
for I:=1 to M do
 begin
_3:
  YX[I-1] := YP[I-1];
 end;
X := XP;
_8:
EPS1 := EPS/32.0;
I1 := 1 + M;
I2 := I1 + M;
I3 := I2 + M;
I4 := I3 + M;
FJ (X,YX,A,M);
FX (X,YX,R3,M);
_18:
DE96RS (F,M,YX,X,A,R3,H,R2,RAB[0],RAB[I1-1],RAB[I2-1],
     RAB[I3-1],RAB[I4-1],A1);
_19:
HS := H;
H := H/2.0;
DE96RS (F,M,YX,X,A,R3,H,R1,RAB[0],RAB[I1-1],RAB[I2-1],
     RAB[I3-1],RAB[I4-1],A1);
FJ (X+H,R1,A2,M);
FX (X+H,R1,R4,M);
DE96RS (F,M,R1,X+H,A2,R4,H,YD,RAB[0],RAB[I1-1],RAB[I2-1],
     RAB[I3-1],RAB[I4-1],A1);
H := HS;
for I:=1 to M do
 begin
  RAB[I-1] := (YD[I-1] - R2[I-1])/15.0;
  XT := Abs(RAB[I-1]);
  if ( Abs(YD[I-1]) >= P ) 
   then XT := XT/Abs(YD[I-1]);
  if ( XT > EPS ) 
   then goto _100;
  if ( XT >= EPS1 ) 
   then BULD := False;
_80:
 end;
XP := X;
X := X + H;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_85:
  YX[I-1] := YD[I-1];
 end;
if ( BULD ) 
 then H := H*2.0;
goto _130;
_100:
if ( BULHM ) 
 then goto _110;
H := H/2.0;
BUL := False;
if ( Abs(H) > Abs(HMIN) ) 
 then goto _105;
H := Sign(HMIN,H);
BULHM := True;
goto _18;
_105:
for I:=1 to M do
 begin
_106:
  R2[I-1] := R1[I-1];
 end;
goto _19;
_110:
IERR := 65;
UTDE20 (94,IERR);
_130:
JSTART := 1;
end;

end.
