Unit DE92RK_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure DE92RK(M :Integer; var A :Array of Real;
                var R1 :Array of Real; H :Real;
                var R2 :Array of Real);

implementation

procedure DE92RK(M :Integer; var A :Array of Real;
                var R1 :Array of Real; H :Real;
                var R2 :Array of Real);
var
I,J :Integer;
S :Real;
label
_20,_10;
begin
for J:=1 to M do
 begin
  S := 0.0;
  for I:=1 to M do
   begin
    S := S + A[(J-1)+(I-1)*M]*R1[I-1];
_20:
   end;
  R2[J-1] := S*H;
_10:
 end;
end;

end.
